# from functools import lru_cache
# from typing import Annotated

from fastapi import FastAPI, Request  # , Depends

import models.secrets as secrets
from database import engine

from fastapi.staticfiles import StaticFiles
from fastapi.templating import Jinja2Templates
from fastapi.responses import HTMLResponse


from config import settings
from routers import secret

secrets.Base.metadata.create_all(bind=engine)

app = FastAPI(
    description="A Fast OTS",
    title=settings.app_name,
    version=settings.app_version
)


app.mount("/static", StaticFiles(directory="web"), name="web")
templates = Jinja2Templates(directory="web/templates")


app.include_router(secret.router)


@app.get("/", response_class=HTMLResponse)
async def index(request: Request, settings=settings):

    return templates.TemplateResponse("index.html",
                                      {"request": request,
                                       "settings": settings})
