from datetime import datetime
from .secrets import Secret

from pydantic import BaseModel, Field


class SecretClearCreate(BaseModel):
    text: str
    password: str = Field(default_factory=Secret.genPassword)
    reads: int = 1

    class Config:
        from_attributes = True


class SecretCreate(BaseModel):
    secret: str
    iv: str
    reads: int = 1

    class Config:
        from_attributes = True


class Secret(SecretCreate):
    uid: str
    expire: datetime


class SecretClear(Secret):
    password: str
